package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Signature;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SignatureSet")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SignatureSet implements Marshallable {
	private Account account;
	private Signature[] signatures;

    //
	public Account getAccount() {
	    return account;
	}
	public void setAccount(final Account value) {
	    this.account = value;
	}

	public SignatureSet account(final Account value) {
	    setAccount(value);
	    return this;
	}
	public Signature[] getSignatures() {
	    return signatures;
	}
	public void setSignatures(final Signature[] value) {
	    this.signatures = value;
	}

	public SignatureSet signatures(final Signature[] value) {
	    setSignatures(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.account == null)) {
            marshaller.writeValue(1, account);
        }
        if (!(this.signatures == null)) {
            marshaller.writeValue(2, signatures);
        }
        return marshaller.array();
    }
}
